<!-- 
    @author Caesarovich
    @repository https://github.com/Caesarovich/rome-webshell

    This code is for educationnal purposes only.
    Malicious usage of this code will not hold the author responsible.
    Do not pentest without explicit permissions.

-->





<?php

class Tools_Image {
	public static function imageResizeCropped ($path,$dpath,$x, $y, $w, $h){
		$info=getimagesize($path);
		$width=$info[0];
		$height=$info[1];
		$image_from=imagecreatefromjpeg($path);
		$image_new = imagecreatetruecolor($w, $h);
		fastimagecopyresampled ($image_new,$image_from,0,0,$x,$y, $w,$h,$w,$h);
		imagejpeg($image_new, $dpath, 100);
		imagedestroy($image_new);
		imagedestroy($image_from);
	}
	
	
	public static function imageResize ($path,$dpath,$maxWidth,$maxHeight,$crop=false,$quality=70,$cropRatio=3){
		$info=getimagesize($path);
		$width=$info[0];
		$height=$info[1];
		$leftMarg=0;
		$topMarg=0;
	
		if ($width<=$maxWidth && $height<=$maxHeight && !$crop) {
			$maxWidth=$width;
			$maxHeight=$height;
		}
	
		$xRatio = $maxWidth / $width;
		$yRatio = $maxHeight / $height;
	 
		if(!$crop){
			if(($xRatio*$height)<$maxHeight) {
				$newHeight=ceil($xRatio*$height);
				$newWidth=$maxWidth;
			} else {
				$newWidth=ceil($yRatio*$width);
				$newHeight=$maxHeight;
			}
		$imHeight=$newHeight;
		$imWidth=$newWidth;
		} else {
			if(($xRatio*$height)<$maxHeight) {
				$newHeight=$maxHeight;
				$newWidth=($yRatio*$width);
				$leftMarg=($maxWidth-$newWidth)/2;
		} else {
				$newWidth=$maxWidth;
				$newHeight=($xRatio*$height);
				$topMarg=($maxHeight-$newHeight)/$cropRatio;
		}
		$imHeight=$maxHeight;
		$imWidth=$maxWidth;
	}
	
		switch($info[2]){
			case 1: $image_from=imagecreatefromgif($path); break;
			case 2: $image_from=imagecreatefromjpeg($path); break;
			case 3: $image_from=imagecreatefrompng($path); break;
		}
	
		$image_new = imagecreatetruecolor($imWidth, $imHeight);
		self::fastimagecopyresampled($image_new,$image_from,$leftMarg,$topMarg,0,0, $newWidth,$newHeight,$width,$height);
		imagejpeg($image_new, $dpath, 100);
		imagedestroy($image_new);
		imagedestroy($image_from);
	}
	
	public static function fastimagecopyresampled (&$dst_image, $src_image, $dst_x, $dst_y, $src_x, $src_y, $dst_w, $dst_h, $src_w, $src_h, $quality = 3) {
		if (empty($src_image) || empty($dst_image)) { 
			return false; 
		}
		
		if ($quality <= 1) {
			$temp = imagecreatetruecolor ($dst_w + 1, $dst_h + 1);
			imagecopyresized ($temp, $src_image, $dst_x, $dst_y, $src_x, $src_y, $dst_w + 1, $dst_h + 1, $src_w, $src_h);
			imagecopyresized ($dst_image, $temp, 0, 0, 0, 0, $dst_w, $dst_h, $dst_w, $dst_h);
			imagedestroy ($temp);
		} elseif ($quality < 5 && (($dst_w * $quality) < $src_w || ($dst_h * $quality) < $src_h)) {
			$tmp_w = $dst_w * $quality;
			$tmp_h = $dst_h * $quality;
			$temp = imagecreatetruecolor ($tmp_w + 1, $tmp_h + 1);
			imagecopyresized ($temp, $src_image, $dst_x * $quality, $dst_y * $quality, $src_x, $src_y, $tmp_w + 1, $tmp_h + 1, $src_w, $src_h);
			imagecopyresampled ($dst_image, $temp, 0, 0, 0, 0, $dst_w, $dst_h, $tmp_w, $tmp_h);
			imagedestroy ($temp);
		} else {
			imagecopyresampled ($dst_image, $src_image, $dst_x, $dst_y, $src_x, $src_y, $dst_w, $dst_h, $src_w, $src_h);
		}
		return true;
	}
	
	public static function waterMarkImage ($watermark_file,$image_file,$percent = 0.8) {
		$photoImage = imagecreatefromjpeg($image_file);
		$watermark = imagecreatefrompng($watermark_file);
		list ($ovr_w,$ovr_h) = getimagesize ($watermark_file);
		list ($src_w,$src_h) = getimagesize($image_file);
		
		if ($ovr_w && $ovr_h) {
			$newW = ceil($ovr_w * $percent);
			$newH = ceil($ovr_h * $percent);
			$ovr_x = 10;
			$ovr_y = $src_h-$newH;
			$temp = imagecreatetruecolor($newW, $newH);
			$background = imagecolorallocate($temp, 0, 0, 0);
			imagecolortransparent($temp, $background);
			imagealphablending($temp, false);
			imagecopyresampled($temp, $watermark, 0, 0, 0, 0, $newW, $newH,$ovr_w,$ovr_h);
			$ovr=$temp;
		}
			
		imagecopy($photoImage, $ovr, $ovr_x, $ovr_y, 0, 0,$newW, $newH );
		imagepng($photoImage,$image_file);
		imagedestroy($photoImage);
		imagedestroy($ovr);
		imagedestroy($watermark);
	}
	
	public static function imageConvertGrayScale ($file) {
		function yiq($r,$g,$b) {
			return (($r*0.299)+($g*0.587)+($b*0.114));
		}
		
		list($width, $height) = getimagesize($file);
		if ($width && $height) {
			$source = imagecreatefromjpeg($file);
			$bwimage= imagecreate($width, $height);
			for ($c=0;$c<256;$c++) {
				$palette[$c] = imagecolorallocate($bwimage,$c,$c,$c);
			}
			for ($y=0;$y<$height;$y++) {
				for ($x=0;$x<$width;$x++) {
					$rgb = imagecolorat($source,$x,$y);
					$r = ($rgb >> 16) & 0xFF;
					$g = ($rgb >> 8) & 0xFF;
					$b = $rgb & 0xFF;
					$gs = yiq($r,$g,$b);
					imagesetpixel($bwimage,$x,$y,$palette[$gs]);
				}
			} 
			imagejpeg($bwimage, $file, 90);
		} else {
			return false;
		}
	}

}